> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.coperniq.io/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.coperniq.io/_mcp/server.

# Update Bill

PATCH https://api.coperniq.io/v1/bills/{bill_id}
Content-Type: application/json

Update an existing bill. Supports partial updates.

Updatable fields:
- `calculationMethod`: Must be "LINE_ITEMS" or "PERCENTAGE"
- `lineItems`: Array of line items if calculationMethod is "LINE_ITEMS"
- `percentage`: Percentage if calculationMethod is "PERCENTAGE"
- `dueDate`: ISO 8601 datetime string
- `issueDate`: ISO 8601 datetime string
- `description`: Bill description
- `status`: Bill status


Reference: https://docs.coperniq.io/api-reference/bills/update-bill

## Authentication

- `x-api-key` header (required) — API Key authentication via header

## Request

### Path parameters

- `bill_id` (integer, required) — Bill identifier

### Body (application/json)

This endpoint expects a BillUpdate.

- `lineItems` (list of BillLineItemCreate, optional) — Flat array of line items (LINE_ITEMS bills only). May be combined with `sections` (a catalogItemId may appear only once across both).
- `sections` (list of BillSection, optional) — Grouped line items with named sections (LINE_ITEMS bills only). May be combined with `lineItems` (ungrouped items).
- `percentage` (double, optional) — Percentage value (PERCENTAGE bills only)
- `dueDate` (string, optional) — Due date (ISO 8601 datetime string)
- `issueDate` (string, optional) — Issue date (LINE_ITEMS bills only). When provided, `status` must also be provided and must not be `DRAFT`.
- `status` (enum, optional) — Bill status (LINE_ITEMS bills only). Only valid when `issueDate` is also provided.
  - Allowed values: `SENT`, `PARTIALLY_PAID`, `PAID`
- `description` (string, optional, nullable) — Bill description

## Response

### 200

Bill updated successfully

- `id` (integer, required) — Bill identifier
- `billNumber` (integer, required) — Unique bill number
- `status` (enum, required) — Bill status
  - Allowed values: `DRAFT`, `SENT`, `DECLINED`, `PAID`, `PARTIALLY_PAID`, `OVERDUE`
- `amount` (double, required) — Total bill amount
- `amountPaid` (double, required) — Amount paid
- `calculationMethod` (string, required) — Calculation method (LINE_ITEMS or PERCENTAGE)
- `createdAt` (string, required) — Creation timestamp
- `updatedAt` (string, required) — Last update timestamp
- `description` (string, optional, nullable) — Bill description
- `basedOnId` (integer, optional, nullable) — ID of the record this bill is based on
- `basedOnUid` (integer, optional, nullable) — UID of the record this bill is based on
- `dueDate` (string, optional) — Due date
- `issueDate` (string, optional, nullable) — Issue date
- `isArchived` (boolean, optional) — Whether the bill is archived
- `percentage` (double, optional, nullable) — Percentage if calculationMethod is PERCENTAGE
- `baseAmount` (double, optional, nullable) — Base amount if calculationMethod is PERCENTAGE
- `account` (BillAccount, optional, nullable)
- `record` (BillRecord, optional, nullable)
- `lineItems` (list of BillLineItem, optional)

## Errors

### 400 Bad Request Error

Invalid request

- `message` (string, optional)
- `code` (enum, optional)
  - Allowed values: `NOT_FOUND`
- `field` (string, optional) — Field that caused the validation error (if applicable)

### 401 Unauthorized Error

Authentication failed

- `message` (string, optional)
- `code` (enum, optional)
  - Allowed values: `NOT_FOUND`

### 404 Not Found Error

Resource not found

- `message` (string, optional)
- `code` (enum, optional)
  - Allowed values: `NOT_FOUND`

## Types

### BillLineItemCreate

- `catalogItemId` (integer, required) — Catalog item identifier
- `quantity` (integer, required) — Quantity
- `unitCost` (double, required) — Cost per unit — must be greater than 0 for bills
- `unitPrice` (double, required) — Price per unit — may be negative for discounts
- `id` (integer, optional, default: 0) — Line item ID (0 for new items)
- `description` (string, optional, nullable) — Line item description

### BillSection

A named section grouping one or more bill line items.

- `lineItems` (list of BillLineItemCreate, required) — Line items within this section (at least one required). `unitCost` must be greater than 0.
- `id` (integer, optional) — Existing section ID (omit for new sections)
- `name` (string, optional, nullable) — Section name (1–500 chars). Omit or pass null for an unnamed section.

### BillAccount

- `id` (integer, optional)
- `title` (string, optional)

### BillRecord

- `id` (integer, optional)
- `uid` (integer, optional)
- `title` (string, optional)

### BillLineItem

- `id` (integer, required) — Line item identifier
- `catalogItemId` (integer, required) — Catalog item identifier
- `quantity` (integer, required) — Quantity
- `unitCost` (double, required) — Cost per unit (must be greater than 0 for bills)
- `unitPrice` (double, required) — Price per unit (may be negative for discounts)
- `description` (string, optional, nullable) — Line item description
- `catalogItem` (BillLineItemCatalogItem, optional, nullable)

### BillLineItemCatalogItem

- `id` (integer, optional)
- `name` (string, optional)
- `manufacturer` (string, optional, nullable)
- `sku` (string, optional, nullable)
- `type` (enum, optional)
  - Allowed values: `PRODUCT`, `SERVICE`

## Examples

**Request**

```json
{}
```

**Response**

```json
{
  "id": 1,
  "billNumber": 1,
  "status": "DRAFT",
  "amount": 1.1,
  "amountPaid": 1.1,
  "calculationMethod": "string",
  "createdAt": "2024-01-15T09:30:00Z",
  "updatedAt": "2024-01-15T09:30:00Z",
  "description": "string",
  "basedOnId": 1,
  "basedOnUid": 1,
  "dueDate": "2024-01-15T09:30:00Z",
  "issueDate": "2024-01-15T09:30:00Z",
  "isArchived": true,
  "percentage": 1.1,
  "baseAmount": 1.1,
  "account": {
    "id": 1,
    "title": "string"
  },
  "record": {
    "id": 1,
    "uid": 1,
    "title": "string"
  },
  "lineItems": [
    {
      "id": 1,
      "catalogItemId": 1,
      "quantity": 1,
      "unitCost": 1.1,
      "unitPrice": 1.1,
      "description": "string",
      "catalogItem": {
        "id": 1,
        "name": "string",
        "manufacturer": "string",
        "sku": "string",
        "type": "PRODUCT"
      }
    }
  ]
}
```

**SDK Code**

```python
import requests

url = "https://api.coperniq.io/v1/bills/1"

payload = {}
headers = {
    "x-api-key": "<apiKey>",
    "Content-Type": "application/json"
}

response = requests.patch(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.coperniq.io/v1/bills/1';
const options = {
  method: 'PATCH',
  headers: {'x-api-key': '<apiKey>', 'Content-Type': 'application/json'},
  body: '{}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.coperniq.io/v1/bills/1"

	payload := strings.NewReader("{}")

	req, _ := http.NewRequest("PATCH", url, payload)

	req.Header.Add("x-api-key", "<apiKey>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.coperniq.io/v1/bills/1")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Patch.new(url)
request["x-api-key"] = '<apiKey>'
request["Content-Type"] = 'application/json'
request.body = "{}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.patch("https://api.coperniq.io/v1/bills/1")
  .header("x-api-key", "<apiKey>")
  .header("Content-Type", "application/json")
  .body("{}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('PATCH', 'https://api.coperniq.io/v1/bills/1', [
  'body' => '{}',
  'headers' => [
    'Content-Type' => 'application/json',
    'x-api-key' => '<apiKey>',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.coperniq.io/v1/bills/1");
var request = new RestRequest(Method.PATCH);
request.AddHeader("x-api-key", "<apiKey>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "x-api-key": "<apiKey>",
  "Content-Type": "application/json"
]
let parameters = [] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.coperniq.io/v1/bills/1")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "PATCH"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```